import { DynamoDB } from "@aws-sdk/client-dynamodb";
import { DynamoPaginationOptions } from "../dto/request/dynamo-pagination.options";
import { DynamoPaginationRequest } from "../dto/request/dynamo-pagination.request";
import { DynamoFilterRequest } from "../dto/request/dynamo-filter.request";
import { DynamoPaginationResponse } from "../dto/response/dynamo-pagination.response";
export declare class DynamoPagination {
    private dynamodb;
    constructor(dynamodb: DynamoDB);
    columns: string[];
    placeholders: string[];
    condition: string;
    pagination(options: DynamoPaginationOptions, params?: DynamoPaginationRequest, logs?: boolean): Promise<DynamoPaginationResponse>;
    getCondition(options: DynamoPaginationOptions, filters: DynamoFilterRequest[]): string;
    private _setFilter;
    private _verifyFilterAttribute;
    private _processFilter;
    private _processSimpleFilter;
    private _processColumnFilter;
    private _processBetweenFilter;
    private _processInFilter;
    private _processIsFilter;
    private _processSubFilter;
    private _getConn;
    private _setPlaceholder;
}
