"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DynamoFilterRequest = void 0;
const class_validator_1 = require("class-validator");
const enums_1 = require("../../enums/enums");
const class_transformer_1 = require("class-transformer");
class DynamoFilterRequest {
    constructor() {
        this.type = enums_1.DynamoFilterType.SIMPLE;
        this.attr = null;
        this.val = null;
        this.opr = enums_1.DynamoFilterOperator.EQUAL;
        this.conn = enums_1.DynamoFilterLogical.AND;
        this.subfilters = [];
    }
}
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.IsEnum)(enums_1.DynamoFilterType)
], DynamoFilterRequest.prototype, "type", void 0);
__decorate([
    (0, class_validator_1.ValidateIf)((val) => val.type === enums_1.DynamoFilterType.SUB),
    (0, class_validator_1.IsDefined)()
], DynamoFilterRequest.prototype, "attr", void 0);
__decorate([
    (0, class_validator_1.ValidateIf)((val) => val.type === enums_1.DynamoFilterType.SUB),
    (0, class_validator_1.IsDefined)()
], DynamoFilterRequest.prototype, "val", void 0);
__decorate([
    (0, class_validator_1.ValidateIf)((val) => val.type !== enums_1.DynamoFilterType.SUB),
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.IsEnum)(enums_1.DynamoFilterOperator)
], DynamoFilterRequest.prototype, "opr", void 0);
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.IsEnum)(enums_1.DynamoFilterLogical)
], DynamoFilterRequest.prototype, "conn", void 0);
__decorate([
    (0, class_validator_1.ValidateIf)((val) => val.type === enums_1.DynamoFilterType.SUB),
    (0, class_validator_1.IsDefined)(),
    (0, class_validator_1.IsArray)(),
    (0, class_transformer_1.Type)(() => (DynamoFilterRequest)),
    (0, class_validator_1.ValidateNested)()
], DynamoFilterRequest.prototype, "subfilters", void 0);
exports.DynamoFilterRequest = DynamoFilterRequest;
